#include "Client_BSD_Communicator.h"

/******************************************************
 * connect to a remote host (client-side only).
 * PRE:I have been opened.
 * POST: I have connected to myRemoteHost.
 ******************************************************/
void Client_BSD_Communicator::connect()
{
  if (std::connect(getDescriptor(),
	      addressInfo()->addressInfoOldFormat(),
	      addressInfo()->size())
      < 0)
    {
      fatal("BSD_Client_Communicator::connect(): unable to connect socket");
    }
}


/*****************************************************************
 * open with (Service, Host)
 * PRE: serviceName holds the name of a valid TCP Service;
 *      hostName is the name of a defined IP host.
 * POST: myServiceInfo == service && myRemoteHost = hostName.
 *****************************************************************/

void Client_BSD_Communicator::open(Service * service,
					 const Host & host)
{
  myRemoteHost = host;
  BSD_Communicator::start(service);
  BSD_Communicator::setAddressInfo(new ClientSocketAddress(host, *service));
  connect();
}

