#include "NetworkObject.h"

/**************************************************
 * Generate fatal error
 * PRE: format is a format-string, a la printf...
 * POST: format and trailing arguments have been
 *        displayed, and the program terminated.
 **************************************************/

void NetworkObject::fatal(const char * format, ...) const
{
  fprintf(stderr, "\n\n*** Error: ");
  va_list args;
  va_start(args, format);
  vfprintf(stderr, format, args);
  va_end(args);
  perror("\nSystem Error Message:");
  fprintf(stderr, "\n\n");
  exit(1);
}

/**************************************************
 * Generate (nonfatal) warning
 * PRE: format is a format-string, a la printf...
 * POST: format and trailing arguments have been
 *        displayed.
 **************************************************/

void NetworkObject::warning(const char * format, ...) const
{
  fprintf(stderr, "\n\n* warning: ");
  va_list args;
  va_start(args, format);
  vfprintf(stderr, format, args);
  va_end(args);
  perror("\n");
  fprintf(stderr, "\n\n");
}
