/* ClientSocketAddress.h extends the SocketAddress implementation for clients.
 *
 * Author: Joel Adams
 * Date: December 1998
 * Version: 0.9
 */


#ifndef CLIENT_SOCKET_ADDRESS
#define CLIENT_SOCKET_ADDRESS

#include "SocketAddress.h"
using namespace std;

class ClientSocketAddress : public SocketAddress
{
 public:
  ClientSocketAddress();
  ClientSocketAddress(const string & hostName, const unsigned short port);
  ClientSocketAddress(const Host & host, const unsigned short port);
  ClientSocketAddress(const string & hostName, const Service & service);
  ClientSocketAddress(const Host & host, const Service & service);
  
  virtual ~ClientSocketAddress();

 protected:

 private:

};

inline ClientSocketAddress::ClientSocketAddress()
  : SocketAddress()
{}

inline ClientSocketAddress::ClientSocketAddress(const string & hostName,
					       const unsigned short port)
  : SocketAddress(hostName, port)
{
  SocketAddress::addressInfo()->sin_addr.s_addr = addressNBO();
}


inline ClientSocketAddress::ClientSocketAddress(const Host & host, 
						const unsigned short port)
  : SocketAddress(host, port)
{
  SocketAddress::addressInfo()->sin_addr.s_addr = addressNBO();
}


inline ClientSocketAddress::ClientSocketAddress(const string & hostName, 
						const Service & service)
  : SocketAddress(hostName, service)
{
  SocketAddress::addressInfo()->sin_addr.s_addr = addressNBO();
}


inline ClientSocketAddress::ClientSocketAddress(const Host & host, 
						const Service & service)
  : SocketAddress(host, service)
{
  SocketAddress::addressInfo()->sin_addr.s_addr = addressNBO();
}

inline ClientSocketAddress::~ClientSocketAddress()
{}

#endif
