/* TCP_Proto.h provides a simplified interface for the 
 *  tcp protocol.  Most of its functionality is inherited.
 *
 * Author: Joel C. Adams.
 * Date: October, 1998.
 * Version: 0.8
 */

#ifndef TCP_PROTOCOL
#define TCP_PROTOCOL

#include "Proto.h"
using namespace std;

class TCP_Protocol : public Protocol
{
 public:
  TCP_Protocol();
  virtual ~TCP_Protocol();

  virtual string className() const;

  int BSD_Info() const;
  char * TLI_Info() const;

 protected:

 private:

};

/************************************************
 * Default constructor.
 * POST: Data members are set to default values.
 ************************************************/
inline TCP_Protocol::TCP_Protocol()
  : Protocol("tcp")
{}

/************************************************
 * Destructor (nothing to do)
 ************************************************/

inline TCP_Protocol::~TCP_Protocol()
{}

/*************************************************
 * The information about TCP that a BSD socket needs.
 * POST: RV == SOCK_STREAM.
 *************************************************/

inline int TCP_Protocol::BSD_Info() const
{
  return SOCK_STREAM;
}

/*************************************************
 * The information about TCP that a TLI socket needs.
 * POST: RV == "/dev/tcp".
 *************************************************/

inline char * TCP_Protocol::TLI_Info() const
{
  return "/dev/tcp";
}

/**************************************************
 * className function (for diagnostics)
 * POST: RV == "TCP_Protocol"
 **************************************************/

inline string TCP_Protocol::className() const
{
  return "TCP_Protocol";
}

#endif



