/* UDP_Proto.h provides a simplified interface for the 
 *  udp protocol.  Most of its functionality is inherited.
 *
 * Author: Joel C. Adams.
 * Date: October, 1998.
 * Version: 0.8
 */

#ifndef UDP_PROTOCOL
#define UDP_PROTOCOL

#include "Proto.h"
using namespace std;

class UDP_Protocol : public Protocol
{
 public:
  UDP_Protocol();
  virtual ~UDP_Protocol();

  virtual string className() const;

  int BSD_Info() const;
  char * TLI_Info() const;

 protected:

 private:

};

/************************************************
 * Default constructor.
 * POST: Data members are set to default values.
 ************************************************/
inline UDP_Protocol::UDP_Protocol()
  : Protocol("udp")
{}

/************************************************
 * Destructor (nothing to do)
 ************************************************/

inline UDP_Protocol::~UDP_Protocol()
{}

/*************************************************
 * The information about UDP that a BSD socket needs.
 * POST: RV == SOCK_STREAM.
 *************************************************/

inline int UDP_Protocol::BSD_Info() const
{
  return SOCK_DGRAM;
}

/*************************************************
 * The information about UDP that a TLI socket needs.
 * POST: RV == "/dev/udp".
 *************************************************/

inline char * UDP_Protocol::TLI_Info() const
{
  return "/dev/udp";
}


/**************************************************
 * className information (for diagnostics)
 * POST: RV == "UDP_Protocol".
 **************************************************/

inline string UDP_Protocol::className() const
{
  return "UDP_Protocol";
}


#endif
