#include "Client_Winsock_Communicator.h"

/******************************************************
 * connect to a remote host (client-side only).
 * PRE:I have been opened.
 * POST: I have connected to myRemoteHost.
 ******************************************************/

void Client_Winsock_Communicator::connect()
{
  if (::connect(getDescriptor(),
	      addressInfo()->addressInfoOldFormat(),
	      addressInfo()->size())
      == SOCKET_ERROR)
    {
      fatal("Winsock_Client_Communicator::connect(): unable to connect socket");
    }
}


/*****************************************************************
 * open with (Service, Host)
 * PRE: serviceName holds the name of a valid TCP Service;
 *      hostName is the name of a defined IP host.
 * POST: myServiceInfo == service && myRemoteHost = hostName.
 *****************************************************************/

void Client_Winsock_Communicator::open(Service * service,
					 const Host & host)
{
  myRemoteHost = host;
  Winsock_Communicator::start(service);
  Winsock_Communicator::setAddressInfo(new ClientSocketAddress(host, *service));
  connect();
}

