#include "UDP_Server_Winsock_Communicator.h"

/*****************************************************************
 * receive - polymorphic: implemented for UDP
 *   receive a message from anyone, and keep the track of the sender
 * PRE: msg is a string
 * POST: 
 *   msg contains the message which was sent to us
 *   last_from contains the address of the person who sent us the
 *   previous message.
 *****************************************************************/
int UDP_Server_Winsock_Communicator::receive(string & msg) {
  const int BUF_SIZE = 1024;
  char buf[BUF_SIZE];
  msg = "";
  int total = 0;
  int count;
  struct sockaddr_in msgSource;
  int senderSize = sizeof(msgSource);
  do
    {
      count = ::recvfrom(getDescriptor(), buf, BUF_SIZE, 0,
		       (struct sockaddr *) &msgSource, 
		       &senderSize);

      if (count == SOCKET_ERROR)
	  fatal("socket error: recvfrom");

      buf[count] = '\0';
      msg += buf;
      total += count;
    }
  while (count >= BUF_SIZE);

  setClient(SocketAddress(msgSource));
  return total;
}

/*****************************************************************
 * operator= - implements the assignment operator
 * PRE: comm is an object which inherits fromUDP_Server_Winsock_Communicator
 * POST: data members are equal to comm's data memebers.
 *****************************************************************/
UDP_Server_Winsock_Communicator & UDP_Server_Winsock_Communicator::operator=(const UDP_Server_Winsock_Communicator & comm)
{
    Server_Winsock_Communicator::operator=(comm);
    this->myFirstMessageFromClient = comm.myFirstMessageFromClient;
    return *this;
}

